"""
    EMIL ClaimService

    The EMIL ClaimService API description  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: kontakt@emil.de
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from eis.claim.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from eis.claim.exceptions import ApiAttributeError



class UpdateClaimRequestDto(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'title': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'account_code': (str,),  # noqa: E501
            'policy_number': (str,),  # noqa: E501
            'policy_code': (str,),  # noqa: E501
            'product_id': (float,),  # noqa: E501
            'product_version_id': (float,),  # noqa: E501
            'product_name': (str,),  # noqa: E501
            'insured_object_id': (float,),  # noqa: E501
            'policy_object_code': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'adjuster': (str,),  # noqa: E501
            'reporter': (str,),  # noqa: E501
            'contact_email': (str,),  # noqa: E501
            'contact_phone': (str,),  # noqa: E501
            'damage_date': (datetime,),  # noqa: E501
            'notification_date': (datetime,),  # noqa: E501
            'custom_fields': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'title': 'title',  # noqa: E501
        'status': 'status',  # noqa: E501
        'account_code': 'accountCode',  # noqa: E501
        'policy_number': 'policyNumber',  # noqa: E501
        'policy_code': 'policyCode',  # noqa: E501
        'product_id': 'productId',  # noqa: E501
        'product_version_id': 'productVersionId',  # noqa: E501
        'product_name': 'productName',  # noqa: E501
        'insured_object_id': 'insuredObjectId',  # noqa: E501
        'policy_object_code': 'policyObjectCode',  # noqa: E501
        'description': 'description',  # noqa: E501
        'adjuster': 'adjuster',  # noqa: E501
        'reporter': 'reporter',  # noqa: E501
        'contact_email': 'contactEmail',  # noqa: E501
        'contact_phone': 'contactPhone',  # noqa: E501
        'damage_date': 'damageDate',  # noqa: E501
        'notification_date': 'notificationDate',  # noqa: E501
        'custom_fields': 'customFields',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, title, status, account_code, policy_number, policy_code, product_id, product_version_id, product_name, insured_object_id, policy_object_code, description, adjuster, reporter, contact_email, contact_phone, damage_date, notification_date, custom_fields, *args, **kwargs):  # noqa: E501
        """UpdateClaimRequestDto - a model defined in OpenAPI

        Args:
            title (str): Field to enter the claim title.
            status (str): The current status of the claim.
            account_code (str): Unique identifier of the account that the claim belongs to.
            policy_number (str): Field for the policy number that the claim belongs to.
            policy_code (str): Field for the policy code that the claim belongs to.
            product_id (float): Unique identifier referencing the product.
            product_version_id (float): Unique identifier referencing the product version.
            product_name (str): The name of the product.
            insured_object_id (float): The insured object identifier that the claim is made for.
            policy_object_code (str): The policy object code that the claim is made for.
            description (str): The claim's description in 5000 characters.
            adjuster (str): The adjuster of the claim.       A claim adjuster investigates insurance claims by interviewing the claimant and witnesses, consulting police and       hospital records, and inspecting property damage to determine the extent of the insurance company's liability.
            reporter (str): A claim reporter is responsible for submitting this claim to the platform.     A claim reporter is not necessarily the same as the policy holder.
            contact_email (str): The contact email of the policyholder.
            contact_phone (str): The contact phone of the policyholder.
            damage_date (datetime): The claim's damage date.
            notification_date (datetime): The date on which the claim is reported.
            custom_fields ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Tenant specific custom fields for claims (e.g. IMEI, Serial Number, etc.).

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.title = title
        self.status = status
        self.account_code = account_code
        self.policy_number = policy_number
        self.policy_code = policy_code
        self.product_id = product_id
        self.product_version_id = product_version_id
        self.product_name = product_name
        self.insured_object_id = insured_object_id
        self.policy_object_code = policy_object_code
        self.description = description
        self.adjuster = adjuster
        self.reporter = reporter
        self.contact_email = contact_email
        self.contact_phone = contact_phone
        self.damage_date = damage_date
        self.notification_date = notification_date
        self.custom_fields = custom_fields
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, title, status, account_code, policy_number, policy_code, product_id, product_version_id, product_name, insured_object_id, policy_object_code, description, adjuster, reporter, contact_email, contact_phone, damage_date, notification_date, custom_fields, *args, **kwargs):  # noqa: E501
        """UpdateClaimRequestDto - a model defined in OpenAPI

        Args:
            title (str): Field to enter the claim title.
            status (str): The current status of the claim.
            account_code (str): Unique identifier of the account that the claim belongs to.
            policy_number (str): Field for the policy number that the claim belongs to.
            policy_code (str): Field for the policy code that the claim belongs to.
            product_id (float): Unique identifier referencing the product.
            product_version_id (float): Unique identifier referencing the product version.
            product_name (str): The name of the product.
            insured_object_id (float): The insured object identifier that the claim is made for.
            policy_object_code (str): The policy object code that the claim is made for.
            description (str): The claim's description in 5000 characters.
            adjuster (str): The adjuster of the claim.       A claim adjuster investigates insurance claims by interviewing the claimant and witnesses, consulting police and       hospital records, and inspecting property damage to determine the extent of the insurance company's liability.
            reporter (str): A claim reporter is responsible for submitting this claim to the platform.     A claim reporter is not necessarily the same as the policy holder.
            contact_email (str): The contact email of the policyholder.
            contact_phone (str): The contact phone of the policyholder.
            damage_date (datetime): The claim's damage date.
            notification_date (datetime): The date on which the claim is reported.
            custom_fields ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Tenant specific custom fields for claims (e.g. IMEI, Serial Number, etc.).

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.title = title
        self.status = status
        self.account_code = account_code
        self.policy_number = policy_number
        self.policy_code = policy_code
        self.product_id = product_id
        self.product_version_id = product_version_id
        self.product_name = product_name
        self.insured_object_id = insured_object_id
        self.policy_object_code = policy_object_code
        self.description = description
        self.adjuster = adjuster
        self.reporter = reporter
        self.contact_email = contact_email
        self.contact_phone = contact_phone
        self.damage_date = damage_date
        self.notification_date = notification_date
        self.custom_fields = custom_fields
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
